/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package vista.Ciudad;

import com.mxgraph.layout.hierarchical.mxHierarchicalLayout;
import com.mxgraph.layout.mxGraphLayout;
import com.mxgraph.layout.mxOrganicLayout;
import com.mxgraph.swing.mxGraphComponent;
import com.mxgraph.swing.util.mxMorphing;
import com.mxgraph.util.mxEvent;
import com.mxgraph.util.mxEventObject;
import com.mxgraph.util.mxEventSource;
import com.mxgraph.view.mxGraph;
import com.mxgraph.view.mxStylesheet;
import controlador.Ciudad.Dao.servicio.CiudadServicio;
import controlador.tda.grafo.Adycencia;
import controlador.tda.grafo.GrafoED;
import controlador.tda.grafo.GrafoEND;
import java.awt.BorderLayout;
import java.awt.Dimension;
import lista.controlador.Lista;

/**
 *
 * @author Jose Yangari
 */
public class FrmPresentarCiudadesGrafo extends javax.swing.JDialog {

    private CiudadServicio cs = null;

    public FrmPresentarCiudadesGrafo(java.awt.Frame parent, boolean modal, CiudadServicio tc) {
        super(parent, modal);
        this.cs = tc;
        initComponents();
        mostrarDatos();
    }

    /**
     * Creates new form FrmGrafo
     */
    public FrmPresentarCiudadesGrafo(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    private void mostrarDatos() {
        mxGraph graph = new mxGraph();
        mxGraphComponent graphComponent = new mxGraphComponent(graph);
        graphComponent.setSize(new Dimension(600, 520));
        jPanel1.add(graphComponent, BorderLayout.CENTER);
        jPanel1.updateUI();

        Object parent = graph.getDefaultParent();

        graph.getModel().beginUpdate();

        try {
            GrafoED ge = cs.getGrafo();

            Lista<Object> vertices = new Lista<>();
            for (int i = 0; i < cs.getGrafo().numVertices(); i++) {
                vertices.insertarNodo(graph.insertVertex(parent, null, cs.getGrafo().obtenerEtiqueta(i + 1), 90, 90, 70, 30));
            }

            for (int i = 1; i <= cs.getGrafo().numVertices(); i++) {

                Lista<Adycencia> lista = cs.getGrafo().adyacentes(i);
                for (int j = 0; j < lista.tamanio(); j++) {
                    Adycencia aux = lista.consultarDatoPosicion(j);
                    graph.insertEdge(parent, null, "", vertices.consultarDatoPosicion(i - 1), vertices.consultarDatoPosicion(aux.getDestino() - 1));
                }
            }
        } catch (Exception e) {
            System.out.println("Hubo un error al mostrar el grafo");
        } finally {
            graph.getModel().endUpdate();
        }
        morphgrph(graph, graphComponent);
        new mxHierarchicalLayout(graph).execute(graph.getDefaultParent());
    }

    private static void morphgrph(mxGraph graph, mxGraphComponent graphComponent) {
        mxGraphLayout layout = new mxOrganicLayout(graph);
        graph.getModel().beginUpdate();
        try {
            layout.execute(graph.getDefaultParent());
        } catch (Exception e) {
        } finally {
            mxMorphing morph = new mxMorphing(graphComponent, 20, 1.5, 20);
            morph.addListener(mxEvent.DONE, new mxEventSource.mxIEventListener() {
                @Override
                public void invoke(Object o, mxEventObject eo) {
                    graph.getModel().endUpdate();
                }
            });
            morph.startAnimation();
        }
    }
    
    private void busqueda_profundidad(){
        int[] v = new int[cs.getGrafoObjeto().numVertices()];
        String[] a = cs.getGrafoObjeto().toStringDFS().split("\t");
        String s = "";
        for (int i = 0; i < cs.getGrafoObjeto().numVertices(); i++) {
            v[i] = Integer.parseInt(a[i]);
            s += cs.getGrafoObjeto().obtenerEtiqueta(v[i]) + " - ";
        }
        txtprofundidad.setText(s);
    }
    
    private void busqueda_anchura(){
        int[] v = new int[cs.getGrafoObjeto().numVertices()];
        String[] a = cs.getGrafoObjeto().toStringBFS().split("\t");
        String s = "";
        for (int i = 0; i < cs.getGrafoObjeto().numVertices(); i++) {
            v[i] = Integer.parseInt(a[i]);
            s += cs.getGrafoObjeto().obtenerEtiqueta(v[i]) + " - ";
        }
        txtanchura.setText(s);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        txtprofundidad = new javax.swing.JTextField();
        txtanchura = new javax.swing.JTextField();
        btnprofundidad = new javax.swing.JButton();
        btnanchura = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(null);

        jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel1.setLayout(null);
        getContentPane().add(jPanel1);
        jPanel1.setBounds(0, 0, 390, 520);

        jPanel2.setBackground(new java.awt.Color(153, 0, 0));
        jPanel2.setLayout(null);

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("BUSQUEDA PROFUNDIDAD");
        jPanel2.add(jLabel1);
        jLabel1.setBounds(20, 20, 200, 20);

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel2.setForeground(new java.awt.Color(255, 255, 255));
        jLabel2.setText("BUSQUEDA ANCHURA");
        jPanel2.add(jLabel2);
        jLabel2.setBounds(20, 170, 160, 20);

        txtprofundidad.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        txtprofundidad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtprofundidadActionPerformed(evt);
            }
        });
        jPanel2.add(txtprofundidad);
        txtprofundidad.setBounds(20, 40, 420, 60);

        txtanchura.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jPanel2.add(txtanchura);
        txtanchura.setBounds(20, 200, 420, 50);

        btnprofundidad.setText("CALCULAR");
        btnprofundidad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnprofundidadActionPerformed(evt);
            }
        });
        jPanel2.add(btnprofundidad);
        btnprofundidad.setBounds(170, 110, 110, 40);

        btnanchura.setText("CALCULAR");
        btnanchura.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnanchuraActionPerformed(evt);
            }
        });
        jPanel2.add(btnanchura);
        btnanchura.setBounds(180, 260, 100, 40);

        jLabel3.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel3.setForeground(new java.awt.Color(255, 255, 255));
        jLabel3.setText("Nota: No agragar nada en los cuadros,"); // NOI18N
        jPanel2.add(jLabel3);
        jLabel3.setBounds(90, 370, 300, 70);

        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel4.setForeground(new java.awt.Color(255, 255, 255));
        jLabel4.setText("solo pulsar el boton calcular."); // NOI18N
        jPanel2.add(jLabel4);
        jLabel4.setBounds(140, 420, 220, 40);

        getContentPane().add(jPanel2);
        jPanel2.setBounds(390, 0, 450, 520);

        setSize(new java.awt.Dimension(855, 564));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void btnprofundidadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnprofundidadActionPerformed
        // TODO add your handling code here:
        busqueda_profundidad();
    }//GEN-LAST:event_btnprofundidadActionPerformed

    private void btnanchuraActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnanchuraActionPerformed
        // TODO add your handling code here:
        busqueda_anchura();
    }//GEN-LAST:event_btnanchuraActionPerformed

    private void txtprofundidadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtprofundidadActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtprofundidadActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;

                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FrmPresentarCiudadesGrafo.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);

        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FrmPresentarCiudadesGrafo.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);

        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FrmPresentarCiudadesGrafo.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);

        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FrmPresentarCiudadesGrafo.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                FrmPresentarCiudadesGrafo dialog = new FrmPresentarCiudadesGrafo(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnanchura;
    private javax.swing.JButton btnprofundidad;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTextField txtanchura;
    private javax.swing.JTextField txtprofundidad;
    // End of variables declaration//GEN-END:variables
}
